import { register } from 'mojang-gametest';
import { world } from "mojang-minecraft";

import { ActionFormData, ModalFormData } from "mojang-minecraft-ui"

register('', '', (test) => { });

world.events.beforeChat.subscribe((eventData) => {
    if (eventData.message == "!wa-help") {
        eventData.cancel = true;
        eventData.sender.runCommand('tellraw @s {"rawtext":[{"text":"Hello! Need any help? §lHere is a list of commands that can help you out! §r§a\n!wa-storms \n!wa spawn tornado 0 \n!wa spawn tornado 1 \n!wa spawn tornado 2"}]}')
    }
    if (eventData.message == "!wa-storms") {
        eventData.cancel = true;
        eventData.sender.runCommand('tellraw @s {"rawtext":[{"text":"The Storm Types, Consists Of The Follwing... §c\nStorm / Supercell / F0 / F1 / F2 / WaterSpout (F0) / WaterSpout (F1) / WaterSpout (F2)"}]}')
    }
    if (eventData.message == "!wa spawn tornado 0") {
        eventData.cancel = true;
        eventData.sender.runCommand('execute @s[tag=!spawn] ~~~ summon agp:tornado0 ~54~~100')
	  eventData.sender.runCommand('execute @e[type=!agp:tornado0,c=1] ~~~ execute @e[type=player,tag=!spawn] ~~~ tellraw @s {"rawtext":[{"text":"§lTornado 0 Spawned..."}]}')
	  eventData.sender.runCommand('execute @s[tag=!spawn] ~~~ tag @s add spawn')
	  eventData.sender.runCommand('execute @s[tag=spawn] ~~~ tellraw @s {"rawtext":[{"text":"§l§cUnable To Summon Object, due to performce issues..."}]}')
    }
    if (eventData.message == "!wa spawn tornado 1") {
        eventData.cancel = true;
        eventData.sender.runCommand('execute @s[tag=!spawn] ~~~ summon agp:tornado1 ~54~~100')
	  eventData.sender.runCommand('execute @e[type=!agp:tornado1,c=1] ~~~ execute @e[type=player,tag=!spawn] ~~~ tellraw @s {"rawtext":[{"text":"§lTornado 1 Spawned..."}]}')
	  eventData.sender.runCommand('execute @s[tag=!spawn] ~~~ tag @s add spawn')
	  eventData.sender.runCommand('execute @s[tag=spawn] ~~~ tellraw @s {"rawtext":[{"text":"§l§cUnable To Summon Object, due to performce issues..."}]}')
    }
    if (eventData.message == "!wa spawn tornado 2") {
        eventData.cancel = true;
        eventData.sender.runCommand('execute @s[tag=!spawn] ~~~ summon agp:tornado2 ~54~~100')
	  eventData.sender.runCommand('execute @e[type=!agp:tornado2,c=1] ~~~ execute @e[type=player,tag=!spawn] ~~~ tellraw @s {"rawtext":[{"text":"§lTornado 2 Spawned..."}]}')
	  eventData.sender.runCommand('execute @s[tag=!spawn] ~~~ tag @s add spawn')
	  eventData.sender.runCommand('execute @s[tag=spawn] ~~~ tellraw @s {"rawtext":[{"text":"§l§cUnable To Summon Object, due to performce issues..."}]}')
    }
});
world.events.beforeItemUse.subscribe((eventData) => {
    let item = eventData.item
    let player = eventData.source

    if (item.id == "agp:settings")
        WeatherMenu(player);
});
function WeatherMenu(player) {
    const form = new ActionFormData()
    form.title('§lWeather Settings Panel')
     form.button('§lSettings')
     form.button('§lToggles')
     form.show(player).then(finalize => {
    if (finalize.selection === 0) {
        WeatherSettings(player);
    }
    if (finalize.selection === 1) {
        WeatherToggles(player);
    }
})};
function WeatherToggles(player) {
    const formUI = new ActionFormData()
     formUI.toggle("Allow Tornadoes", true);
     formUI.toggle("Allow WaterSpouts", true);
     formUI.toggle("Allow Sirens", true);
     formUI.toggle("Show Credits", true);
     formUI.show(player).then(finalize => {
    if (finalize.selection === 0) {
        WeatherSettings(player);
    }
    if (finalize.selection === 1) {
        WeatherToggles(player);
    }
})}
