import { register } from 'mojang-gametest';
import { world } from "mojang-minecraft";

import { ActionFormData, ModalFormData } from "mojang-minecraft-ui"

register('', '', (test) => { });

world.events.beforeChat.subscribe((eventData) => {
    if (eventData.message == "!wa-help") {
        eventData.cancel = true;
	  eventData.sender.runCommand('execute @s ~~~ playsound block.turtle_egg.drop @s')
        eventData.sender.runCommand('tellraw @s {"rawtext":[{"text":"Hello! Need any help? §lHere is a list of commands that can help you out! §r§a\n!wa-storms \n!wa spawn tornado §nvalues: §r§l0 | 1 | 2"}]}')
    }
    if (eventData.message == "!wa-storms") {
        eventData.cancel = true;
	  eventData.sender.runCommand('execute @s ~~~ playsound block.turtle_egg.drop @s')
        eventData.sender.runCommand('tellraw @s {"rawtext":[{"text":"The Storm Types, Consists Of The Follwing... §c\nStorm / Supercell / F0 / F1 / F2 / WaterSpout (F0) / WaterSpout (F1) / WaterSpout (F2)"}]}')
    }
    if (eventData.message == "!wa spawn tornado 0") {
        eventData.cancel = true;
        eventData.sender.runCommand('execute @s ~~~ summon agp:tornado0 ~52~~42')
	  eventData.sender.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§lTornado 0 Spawned..."}]}')
	  eventData.sender.runCommand('execute @s[tag=spawn] ~~~ tellraw @s {"rawtext":[{"text":"§l§cUnable To Summon Object, due to performce issues..."}]}')
    }
    if (eventData.message == "!wa spawn tornado 1") {
        eventData.cancel = true;
        eventData.sender.runCommand('execute @s ~~~ summon agp:tornado1 ~54~~100')
	  eventData.sender.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§lTornado 1 Spawned..."}]}')
	  eventData.sender.runCommand('execute @s[tag=spawn] ~~~ tellraw @s {"rawtext":[{"text":"§l§cUnable To Summon Object, due to performce issues..."}]}')
    }
    if (eventData.message == "!wa spawn tornado 2") {
        eventData.cancel = true;
        eventData.sender.runCommand('execute @s ~~~ summon agp:tornado2 ~54~~100')
	  eventData.sender.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§lTornado 2 Spawned..."}]}')
	  eventData.sender.runCommand('execute @s[tag=spawn] ~~~ tellraw @s {"rawtext":[{"text":"§l§cUnable To Summon Object, due to performce issues..."}]}')
    }
});
world.events.beforeItemUse.subscribe((eventData) => {
    let item = eventData.item
    let player = eventData.source

    if (item.id == "agp:settings") {
        WeatherMenu(player);
        player.runCommand('playsound note.bass @s')
      }
    });
    function WeatherMenu(player) {
        const form = new ActionFormData()
        form.title('§lWeather Menu Panel')
	   form.body('§1This menu is to provide settings to help you change the addon itself to your liking!')
         form.button('§lSettings')
         form.button('§lToggles')
         form.show(player).then(finalize => {
         if (finalize.selection === 0) {
            WeatherSettings(player);
        }
        if (finalize.selection === 1) {
            WeatherToggles(player);
        }
})}
   function WeatherToggles(player) {
       const formUI = new ModalFormData()
	  .title('§lWeather Toggles Panel')
        formUI.toggle("Allow Tornadoes", true);
        formUI.toggle("Allow WaterSpouts", true);
        formUI.toggle("Allow Sirens", true);
        formUI.toggle("Enable Credits", true);
        formUI.show(player).then(finalize => {
        if (finalize.formValues[0] == true) {
	      player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§l§aAllow Tornadoes Enabled"}]}')
	      player.runCommand('execute @s ~~~ playsound note.bell @s')
		player.runCommand('execute @s ~~~ tag @s remove NoTN')
        }
        if (finalize.formValues[0] == false) {
	      player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§l§cAllow Tornadoes Disabled"}]}')
	      player.runCommand('execute @s ~~~ playsound note.bass @s')
		player.runCommand('execute @s ~~~ tag @s add NoTN')
        }
	  if (finalize.formValues[1] == true) {
		player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§l§aAllow WaterSpouts Enabled"}]}')
	      player.runCommand('execute @s ~~~ playsound note.bell @s')
		player.runCommand('execute @s ~~~ tag @s remove NoWS')
        }
        if (finalize.formValues[1] == false) {
		player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§l§cAllow WaterSpouts Disabled"}]}')
	      player.runCommand('execute @s ~~~ playsound note.bass @s')
		player.runCommand('execute @s ~~~ tag @s remove NoWS')
        }
	  if (finalize.formValues[3] == true) {
		player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§l§cAllow Credits Enabled"}]}')
	      player.runCommand('execute @s ~~~ playsound note.bell @s')
		player.runCommand('execute @s ~~~ tag @s add NoSM')
        }
	  if (finalize.formValues[3] == false) {
		player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§l§cAllow Credits Disabled"}]}')
	      player.runCommand('execute @s ~~~ playsound note.bass @s')
		player.runCommand('execute @s ~~~ tag @s add NoSM')
        }
})}
   function WeatherSettings(player) {
        const form = new ActionFormData()
        form.title('§lWeather Settings Panel')
	   form.body('§1This menu is to change the fuctionality of the Tornadoes themselves!')
         form.button('§lTornado Spawner', 'textures/ui/LT')
         form.button('§lTornado Functions', 'textures/ui/LT')
	   form.button('§lSiren Volume')
	   form.button('§lPhases')
         form.show(player).then(finalize => {
         if (finalize.selection === 0) {
            TS(player);
        }
        if (finalize.selection === 1) {
            TF(player);
        }
	  if (finalize.selection === 2) {
            SV(player);
        }
	  if (finalize.selection === 3) {
            Phases(player);
        }
})}
   function TS(player) {
        const formUI = new ModalFormData()
         .title('§lTornado Spawner')
         formUI.dropdown("Tornado Types", ["Spawn F0", "Spawn F1", "Spawn F2"]);
         formUI.show(player).then(finalize => {
         if (finalize.formValues[0] == 0) {
            player.runCommand('execute @s ~~~ tag @s add F0')
		player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§lTornado Spawn Set To F0"}]}')
		player.runCommand('execute @s ~~~ playsound note.bit @s')
	      player.runCommand('execute @s ~~~ tag @s remove F1')
	      player.runCommand('execute @s ~~~ tag @s remove F2')
        }
	  if (finalize.formValues[0] == 1) {
	      player.runCommand('execute @s ~~~ tag @s add F1')
		player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§lTornado Spawn Set To F1"}]}')
		player.runCommand('execute @s ~~~ playsound note.bit @s')
		if (finalize.formValues[0] == 1) {
		    player.runCommand('execute @s ~~~ tag @s remove F2')
	          player.runCommand('execute @s ~~~ tag @s remove F0')
        	}
		if (finalize.formValues[0] == 1) {
	          player.runCommand('execute @s ~~~ tag @s remove F0')
		    player.runCommand('execute @s ~~~ tag @s remove F2')
        	}
        }
	  if (finalize.formValues[0] == 2) {
	      player.runCommand('execute @s ~~~ tag @s add F2')
		player.runCommand('execute @s ~~~ tellraw @s {"rawtext":[{"text":"§lTornado Spawn Set To F2"}]}')
		player.runCommand('execute @s ~~~ playsound note.bit @s')
            player.runCommand('execute @s ~~~ tag @s remove F0')
	      player.runCommand('execute @s ~~~ tag @s remove F1')
        }
})}
   function TF(player) {
        const formUI = new ModalFormData()
         .title('§lTornado Spawner')
         formUI.toggle("Players Fly In Tornado", true);
	   formUI.toggle("All Mobs Fly In Tornado", true);
	   formUI.toggle("§cOnly Neutral Mobs Fly In Tornado", false);
	   formUI.toggle("§cOnly Hostile Mobs Fly In Tornado", false);
	   formUI.toggle("§cTornadoes Spawn Naturally", true);
	   formUI.toggle("Tornadoes Despawn Naturally", true);
	   formUI.toggle("Tornadoes Pick Up Blocks", true);
	   formUI.toggle("§cTornadoes Can Grow", true);
	   formUI.toggle("WaterSpouts Pick Up Blocks / Entities", false);
	   formUI.toggle("WaterSpouts Can Go On Land", false);
         formUI.show(player).then(finalize => {
         if (finalize.formValues[0] == true) {
            player.runCommand('execute @s ~~~ tag @s remove c')
        }
	  if (finalize.formValues[0] == false) {
	      player.runCommand('execute @s ~~~ tag @s add c')
        }
})}
   function SV(player) {
        const formUI = new ModalFormData()
         .title('§lSiren')
         formUI.slider('volume', 0, 100, 25)
         formUI.show(player).then(finalize => {
         if (finalize.formValues[0] == 0) {
            player.runCommand('execute @s ~~~ tag @s add F0')
	      player.runCommand('execute @s ~~~ tag @s remove F1')
	      player.runCommand('execute @s ~~~ tag @s remove F2')
        }
	  if (finalize.formValues[0] == 100) {
	      player.runCommand('execute @s ~~~ playsound note.bell @s')
        }
	  if (finalize.formValues[0] == 50) {
	      player.runCommand('execute @s ~~~ playsound note.bass @s')
        }
})}